"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.h = void 0;
const reactivity_1 = require("../reactivity");
const reconcileArrays_1 = require("./reconcileArrays");
function h(tag, a, b) {
    const properties = (isProps(a) ? a : isProps(b) ? b : {});
    const children = (isChildren(a) ? a : isChildren(b) ? b : []);
    const el = document.createElement(tag);
    foreachProperty(properties, ({ prop, value }) => {
        if (prop.startsWith('on')) {
            el[prop] = pass(value);
        }
        else {
            (0, reactivity_1.effect)(() => el[prop] = evaluate(value));
        }
    });
    (0, reactivity_1.effect)(() => (0, reconcileArrays_1.reconcileArrays)(el, Array.from(el.children), evaluate(children)));
    return el;
}
exports.h = h;
function foreachProperty(properties, callback) {
    Object.entries(properties).forEach(([prop, value]) => callback({
        prop: prop,
        value: value
    }));
}
const isProps = (value) => !!value && typeof value === 'object' && !Array.isArray(value) && typeof value !== 'function';
const isChildren = (value) => !!value && (Array.isArray(value) || typeof value === 'function');
const pass = (prop) => prop;
const evaluate = (prop) => typeof prop !== 'function' ? prop : prop();
//# sourceMappingURL=index.js.map