"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reconcileArrays = void 0;
function reconcileArrays(parentNode, a, b) {
    var _a;
    let bLength = b.length, aEnd = a.length, bEnd = bLength, aStart = 0, bStart = 0, after = (_a = a[aEnd - 1]) === null || _a === void 0 ? void 0 : _a.nextSibling, map = new Map();
    while (aStart < aEnd || bStart < bEnd) {
        if (equal(a[aStart], b[bStart])) {
            aStart++;
            bStart++;
            continue;
        }
        while (equal(a[aEnd - 1], b[bEnd - 1])) {
            aEnd--;
            bEnd--;
        }
        if (aEnd === aStart) {
            let node = after;
            if (bEnd < bLength) {
                if (bStart) {
                    node = a[aStart];
                }
                else {
                    node = a[aEnd - aStart];
                }
            }
            while (bStart < bEnd) {
                parentNode.insertBefore(b[bStart++], node);
            }
        }
        else if (bEnd === bStart) {
            while (aStart < aEnd) {
                if (!map || !map.has(a[aStart]))
                    a[aStart].remove();
                aStart++;
            }
        }
        else if (equal(a[aStart], b[bEnd - 1]) && equal(b[bStart], a[aEnd - 1])) {
            parentNode.insertBefore(a[aEnd - 1], a[aStart]);
            parentNode.insertBefore(a[aStart], a[aEnd - 2].nextSibling);
            aEnd--;
            bEnd--;
            aStart++;
            bStart++;
        }
        else {
            if (map.size === 0) {
                let i = bStart;
                while (i < bEnd)
                    map.set(b[i], i++);
            }
            const index = map.get(a[aStart]);
            if (index != null) {
                if (bStart < index && index < bEnd) {
                    let i = aStart, sequence = 1, t;
                    while (++i < aEnd && i < bEnd) {
                        if ((t = map.get(a[i])) == null || t !== index + sequence)
                            break;
                        sequence++;
                    }
                    if (sequence > index - bStart) {
                        const node = a[aStart];
                        while (bStart < index) {
                            parentNode.insertBefore(b[bStart++], node);
                        }
                    }
                    else
                        parentNode.replaceChild(b[bStart++], a[aStart++]);
                }
                else
                    aStart++;
            }
            else
                a[aStart++].remove();
        }
    }
}
exports.reconcileArrays = reconcileArrays;
function equal(node, other) {
    if (node === null && other === null)
        return true;
    return (node === null || node === void 0 ? void 0 : node.isEqualNode(other)) || false;
}
//# sourceMappingURL=reconcileArrays.js.map